package dev.saramago.couchbaseTransactions.persistance.repository

import dev.saramago.couchbaseTransactions.persistance.domain.Data
import org.springframework.data.couchbase.repository.CouchbaseRepository
import org.springframework.stereotype.Repository
import java.util.UUID

@Repository
interface DataRepository : CouchbaseRepository<Data, String>

fun CouchbaseRepository<Data, String>.nextIdentity(): String {
    return UUID.randomUUID().toString()
}