package dev.saramago.couchbaseTransactions.persistance.service

import dev.saramago.couchbaseTransactions.persistance.command.CreateData
import dev.saramago.couchbaseTransactions.persistance.domain.Data
import dev.saramago.couchbaseTransactions.persistance.repository.DataRepository
import dev.saramago.couchbaseTransactions.persistance.repository.nextIdentity
import org.springframework.stereotype.Service
import org.springframework.transaction.annotation.Transactional
import org.springframework.transaction.support.TransactionSynchronizationManager

@Service
class DataService(
    private val dataRepository: DataRepository
) {
    @Transactional
    fun createData(c: CreateData): String {

        println(
            TransactionSynchronizationManager.isSynchronizationActive()
        )
        println(
            TransactionSynchronizationManager.isActualTransactionActive()
        )


        println(
            TransactionSynchronizationManager.isSynchronizationActive() &&
                TransactionSynchronizationManager.isActualTransactionActive()
        )


        val id = dataRepository.nextIdentity()
        val mapping = Data(id, c.name)
        mapping.markAsCreated()
        dataRepository.save(mapping)
        return id
    }
}