package dev.saramago.couchbaseTransactions.persistance.domain

sealed class DataEvent

data class DataChanged(
    val id: String,
    val propertyName: String,
    val oldValue: Any,
    val newValue: Any,
) : DataEvent()

data class DataCreated(val id: String) : DataEvent()